#include <iostream.h>
int current_year = 2001;
float flat_height = 8.25;
const float pi = 3.14159;

class container {
	public: int percent_loaded;
		// default constructor:
		container () { 
			cout << "container default constructor." << endl;
			}
	};
class box : public container {
	public: float height, width, length;
		// default constructor:
		box () {
			cout << "box default constructor." << endl;
			} 
		// other member function:
		float volume () { return height * width * length;}
	};
class cylinder : public container {
	public: float radius, length;
		// default constructor:
		cylinder () {
			cout << "cylinder default constructor." << endl;
			} 
		// other member function:
		float volume () { return pi * radius * radius * length;}
	};
class sphere : public container {
	public: float radius; int number_spheres;
		// default constructor:
		sphere () {
			cout << "sphere default constructor." << endl;
			} 
		// other member function:
		float volume () { return number_spheres * pi * radius * radius * radius;}
	};
class flat : public container {
	public: float width, length;
		// default constructor:
		flat () {
			cout << "flat default constructor." << endl;
			} 
		// other member function:
		float volume () { return width * flat_height * length;}
	};


class railroad_car {
	public: int year_built;
		// default constructor:
		railroad_car () {
				cout << "railroad default constructor." << endl;
				}
		// other member function:
		int age () { return current_year - year_built;}
	};

class box_car : public railroad_car, public box {
	public: box_car() {
		cout << "box_car default constructor." << endl;
		height = 10.5; width = 9.2; length = 40.0;
		}
	};
class tank_car : public railroad_car, public cylinder {
	public: tank_car() {
		cout << "tank_car default constructor." << endl;
		radius = 3.5; length = 40.0;
		}
	};
class gas_car : public railroad_car, public sphere {
	public: gas_car(int n) {
		cout << "gas_car default constructor." << endl;
		radius = 3.5; number_spheres = n;
		}
	};
class flat_car : public railroad_car, public flat {
	public: flat_car () {
		cout << "flat_car default constructor." << endl;
		width = 9.5; length = 40.0;
		}
	};
class engine : public railroad_car {
	public: engine () {
			cout << "engine default constructor." << endl;
			}
	};
class caboose : public railroad_car {
	public: caboose () {
			cout << "caboose default constructor." << endl;
			}
	};

main () {
	gas_car b(4); 
	b.year_built = 1943;
	b.percent_loaded = 66;
	cout << "the car is " << b.age() << " years old." << endl;
	cout << "and " << b.percent_loaded << " percent loaded." << endl;
	cout << "Its volume is " << b.volume() << " units." << endl;
	}

